;***********************************************************
; This coefficient file is created by ElecFilDes for use
; with the Freescale MC56F84789 digital signal controller.
;***********************************************************
;
;                V0      P2 * Z^(-2)  +  P1 * Z^(-1)  + P0
; Cascades are   --   =  ---------------------------------
;                Vin     D2 * Z^(-2)  +  D1 * Z^(-1)  + 1
;
;ntaps is the number of quadratic sections (cascades)
;the number at the end of each coefficient set is the
;number of times the coefficients had to be divided by 2
;in order to avoid overflow.
;This number is repeated to preserve long coefficient boundaries.
;FILTERTYPE = 2 means that this is an IIR filter
;FILTERTYPE = 3 means that this is a synthesized sine wave
;***********************************************************
; Coefficients of the IIR filter
;***********************************************************
;
ntaps    equ     $B
        org x:
states  ds      12*ntaps
;
T0PRELOAD     EQU     999 
T1PRELOAD     EQU     0 
FILTERTYPE    EQU     2 
;
coef
        dc  $D2ED      ; LEAST SIGNIFICANT WORD OF P2/2
        dc  $3E06       ;  MOST SIGNIFICANT WORD OF P2/2
        dc  $C4F4      ; LEAST SIGNIFICANT WORD OF P1/2
        dc  $8573       ;  MOST SIGNIFICANT WORD OF P1/2
        dc  $D2ED      ; LEAST SIGNIFICANT WORD OF P0/2
        dc  $3E06       ;  MOST SIGNIFICANT WORD OF P0/2
        dc  $5A90      ; LEAST SIGNIFICANT WORD OF -D2/2
        dc  $C3F2       ;  MOST SIGNIFICANT WORD OF -D2/2
        dc  $3B0C      ; LEAST SIGNIFICANT WORD OF -D1/2
        dc  $7A8C       ;  MOST SIGNIFICANT WORD OF -D1/2
        dc   1 
        dc   1 
;
        dc  $3043      ; LEAST SIGNIFICANT WORD OF P2/2
        dc  $3758       ;  MOST SIGNIFICANT WORD OF P2/2
        dc  $86C2      ; LEAST SIGNIFICANT WORD OF P1/2
        dc  $92A7       ;  MOST SIGNIFICANT WORD OF P1/2
        dc  $3043      ; LEAST SIGNIFICANT WORD OF P0/2
        dc  $3758       ;  MOST SIGNIFICANT WORD OF P0/2
        dc  $CEEA      ; LEAST SIGNIFICANT WORD OF -D2/2
        dc  $C393       ;  MOST SIGNIFICANT WORD OF -D2/2
        dc  $4CBE      ; LEAST SIGNIFICANT WORD OF -D1/2
        dc  $7B14       ;  MOST SIGNIFICANT WORD OF -D1/2
        dc   1 
        dc   1 
;
        dc  $96C0      ; LEAST SIGNIFICANT WORD OF P2/2
        dc  $22D7       ;  MOST SIGNIFICANT WORD OF P2/2
        dc  $4FF0      ; LEAST SIGNIFICANT WORD OF P1/2
        dc  $BB29       ;  MOST SIGNIFICANT WORD OF P1/2
        dc  $96C0      ; LEAST SIGNIFICANT WORD OF P0/2
        dc  $22D7       ;  MOST SIGNIFICANT WORD OF P0/2
        dc  $9013      ; LEAST SIGNIFICANT WORD OF -D2/2
        dc  $E200       ;  MOST SIGNIFICANT WORD OF -D2/2
        dc  $EFC3      ; LEAST SIGNIFICANT WORD OF -D1/2
        dc  $3D26       ;  MOST SIGNIFICANT WORD OF -D1/2
        dc   2 
        dc   2 
;
        dc  $EBD8      ; LEAST SIGNIFICANT WORD OF P2/2
        dc  $3202       ;  MOST SIGNIFICANT WORD OF P2/2
        dc  $E7FF      ; LEAST SIGNIFICANT WORD OF P1/2
        dc  $9D30       ;  MOST SIGNIFICANT WORD OF P1/2
        dc  $EBD8      ; LEAST SIGNIFICANT WORD OF P0/2
        dc  $3202       ;  MOST SIGNIFICANT WORD OF P0/2
        dc  $DCD0      ; LEAST SIGNIFICANT WORD OF -D2/2
        dc  $C2F9       ;  MOST SIGNIFICANT WORD OF -D2/2
        dc  $6380      ; LEAST SIGNIFICANT WORD OF -D1/2
        dc  $7BCF       ;  MOST SIGNIFICANT WORD OF -D1/2
        dc   1 
        dc   1 
;
        dc  $2C17      ; LEAST SIGNIFICANT WORD OF P2/2
        dc  $26D5       ;  MOST SIGNIFICANT WORD OF P2/2
        dc  $F36F      ; LEAST SIGNIFICANT WORD OF P1/2
        dc  $B346       ;  MOST SIGNIFICANT WORD OF P1/2
        dc  $2C17      ; LEAST SIGNIFICANT WORD OF P0/2
        dc  $26D5       ;  MOST SIGNIFICANT WORD OF P0/2
        dc  $B213      ; LEAST SIGNIFICANT WORD OF -D2/2
        dc  $E1D8       ;  MOST SIGNIFICANT WORD OF -D2/2
        dc  $0286      ; LEAST SIGNIFICANT WORD OF -D1/2
        dc  $3D36       ;  MOST SIGNIFICANT WORD OF -D1/2
        dc   2 
        dc   2 
;
        dc  $E456      ; LEAST SIGNIFICANT WORD OF P2/2
        dc  $2E21       ;  MOST SIGNIFICANT WORD OF P2/2
        dc  $DFB5      ; LEAST SIGNIFICANT WORD OF P1/2
        dc  $A4DA       ;  MOST SIGNIFICANT WORD OF P1/2
        dc  $E456      ; LEAST SIGNIFICANT WORD OF P0/2
        dc  $2E21       ;  MOST SIGNIFICANT WORD OF P0/2
        dc  $4190      ; LEAST SIGNIFICANT WORD OF -D2/2
        dc  $C238       ;  MOST SIGNIFICANT WORD OF -D2/2
        dc  $F7DB      ; LEAST SIGNIFICANT WORD OF -D1/2
        dc  $7CA8       ;  MOST SIGNIFICANT WORD OF -D1/2
        dc   1 
        dc   1 
;
        dc  $A711      ; LEAST SIGNIFICANT WORD OF P2/2
        dc  $2A93       ;  MOST SIGNIFICANT WORD OF P2/2
        dc  $3F4B      ; LEAST SIGNIFICANT WORD OF P1/2
        dc  $ABE1       ;  MOST SIGNIFICANT WORD OF P1/2
        dc  $A711      ; LEAST SIGNIFICANT WORD OF P0/2
        dc  $2A93       ;  MOST SIGNIFICANT WORD OF P0/2
        dc  $EF03      ; LEAST SIGNIFICANT WORD OF -D2/2
        dc  $E17F       ;  MOST SIGNIFICANT WORD OF -D2/2
        dc  $9C84      ; LEAST SIGNIFICANT WORD OF -D1/2
        dc  $3D77       ;  MOST SIGNIFICANT WORD OF -D1/2
        dc   2 
        dc   2 
;
        dc  $3706      ; LEAST SIGNIFICANT WORD OF P2/2
        dc  $2A88       ;  MOST SIGNIFICANT WORD OF P2/2
        dc  $DB6E      ; LEAST SIGNIFICANT WORD OF P1/2
        dc  $ABF7       ;  MOST SIGNIFICANT WORD OF P1/2
        dc  $3706      ; LEAST SIGNIFICANT WORD OF P0/2
        dc  $2A88       ;  MOST SIGNIFICANT WORD OF P0/2
        dc  $5B6B      ; LEAST SIGNIFICANT WORD OF -D2/2
        dc  $C15E       ;  MOST SIGNIFICANT WORD OF -D2/2
        dc  $DDE3      ; LEAST SIGNIFICANT WORD OF -D1/2
        dc  $7D91       ;  MOST SIGNIFICANT WORD OF -D1/2
        dc   1 
        dc   1 
;
        dc  $9C28      ; LEAST SIGNIFICANT WORD OF P2/2
        dc  $2EDD       ;  MOST SIGNIFICANT WORD OF P2/2
        dc  $FD3F      ; LEAST SIGNIFICANT WORD OF P1/2
        dc  $A367       ;  MOST SIGNIFICANT WORD OF P1/2
        dc  $9C28      ; LEAST SIGNIFICANT WORD OF P0/2
        dc  $2EDD       ;  MOST SIGNIFICANT WORD OF P0/2
        dc  $B4AC      ; LEAST SIGNIFICANT WORD OF -D2/2
        dc  $E0FB       ;  MOST SIGNIFICANT WORD OF -D2/2
        dc  $1C8F      ; LEAST SIGNIFICANT WORD OF -D1/2
        dc  $3DE9       ;  MOST SIGNIFICANT WORD OF -D1/2
        dc   2 
        dc   2 
;
        dc  $C161      ; LEAST SIGNIFICANT WORD OF P2/2
        dc  $1BFD       ;  MOST SIGNIFICANT WORD OF P2/2
        dc  $6B22      ; LEAST SIGNIFICANT WORD OF P1/2
        dc  $C8B2       ;  MOST SIGNIFICANT WORD OF P1/2
        dc  $C161      ; LEAST SIGNIFICANT WORD OF P0/2
        dc  $1BFD       ;  MOST SIGNIFICANT WORD OF P0/2
        dc  $ADDC      ; LEAST SIGNIFICANT WORD OF -D2/2
        dc  $C076       ;  MOST SIGNIFICANT WORD OF -D2/2
        dc  $F584      ; LEAST SIGNIFICANT WORD OF -D1/2
        dc  $7E7F       ;  MOST SIGNIFICANT WORD OF -D1/2
        dc   1 
        dc   1 
;
        dc  $DFA0      ; LEAST SIGNIFICANT WORD OF P2/2
        dc  $2437       ;  MOST SIGNIFICANT WORD OF P2/2
        dc  $4DB6      ; LEAST SIGNIFICANT WORD OF P1/2
        dc  $B871       ;  MOST SIGNIFICANT WORD OF P1/2
        dc  $DFA0      ; LEAST SIGNIFICANT WORD OF P0/2
        dc  $2437       ;  MOST SIGNIFICANT WORD OF P0/2
        dc  $1765      ; LEAST SIGNIFICANT WORD OF -D2/2
        dc  $F02C       ;  MOST SIGNIFICANT WORD OF -D2/2
        dc  $66C3      ; LEAST SIGNIFICANT WORD OF -D1/2
        dc  $1F40       ;  MOST SIGNIFICANT WORD OF -D1/2
        dc   3 
        dc   3 
;
